Two Sum

Code it now: https://oj.leetcode.com/problems/two-sum/ Difficulty: Easy, Frequency: High

Question:
Given an array of integers, find two numbers such that they add up to a specific target number.
The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based. You may assume that each input would have exactly one solution.

Solution:
O(n2) runtime, O(1) space – Brute force:
The brute force approach is simple. Loop through each element x and find if there is another value that equals to target – x. As finding another value requires looping through the rest of array, its runtime complexity is O(n2).

O(n) runtime, O(n) space – Hash table:
We could reduce the runtime complexity of looking up a value to O(1) using a hash map that maps a value to its index.

/*************************************************************************
    > File Name: TwoSum.cpp
    > Author: Mandagod
    > Blog: http://blog.csdn.net/mandagod
    > Mail: manda2003@163.com
    > Created Time: 2016年07月08日 星期五 23时34分10秒
 ************************************************************************/

#include<iostream>
#include<vector>
#include<map>
using namespace std;

class Solution {
public:
    // 1
    vector<int> twoSum(vector<int>& nums, int target) {
        //Key is the number and value is its index in the map.
        map<int, int> hash;
        vector<int> result;
        //if numberToFind is found in map, return them
        for (int i = 0; i < nums.size(); i++) {
            int x = nums[i]; // By index or will by iterator
            if (hash.find(target - x) != hash.end()) {
                result.push_back(hash[target - x]); 
                result.push_back(i);
                return result;
            }
            //number was not found. Put it in the map.
            hash[nums[i]] = i; // By index or iterator
        }
        return result;
    }
};

int main() {
    /*
    Given nums = [2, 7, 11, 15], target = 9,

    Because nums[0] + nums[1] = 2 + 7 = 9,
    return [0, 1].
    */

    // the iterator constructor can also be used to construct from arrays:
    int myints[] = {2, 7, 11, 15};
    vector<int> fifth (myints, myints + sizeof(myints) / sizeof(int) );
    cout << "The contents of fifth are:";
    for (vector<int>::iterator it = fifth.begin(); it != fifth.end(); ++it)
        cout << ' ' << *it;
    cout << '\n';

    Solution sol;
    int target = 9;
    cout << "target: " << target << "\n"; 
    vector<int> res = sol.twoSum(fifth, target);

    cout << "The result of test:";
    for(vector<int>::iterator it = res.begin(); it != res.end(); ++it)
        cout << ' ' << *it;
    cout << "\n";
    return 0;
}

// test result
/*
The contents of fifth are: 2 7 11 15
target: 9
The result of test: 0 1
*/

Follow up:
What if the given input is already sorted in ascending order? See Question [2. Two SumII – Input array is sorted].

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值